#ifndef _H__ACCOUNT
#define _H__ACCOUNT

#include "script.h"

#define ACCOUNT_LENGTH 30 // Ұ
#define PASSWORD_LENGTH 30 // Ұ

#define LOGIN_NOT_FOUND -3
#define BAD_PASSWORD -4
#define ACCOUNT_BANNED -5
#define ACCOUNT_WIPE -6

struct account
{
	char account_name[ACCOUNT_LENGTH];
	struct account* next;
	int is_blocked;
	int is_online;
	char password[PASSWORD_LENGTH];
};

struct account* head;
struct account* tail;

void account_load();
void account_clean();
struct account* account_add_to_list(char acctname[ACCOUNT_LENGTH]);
void account_remove_from_list(struct account* acct);
int authenticate(char* acct, char* pass, int s);

#endif
