#include <stdio.h>
#include <stdlib.h>
#include "verinfo.h"
#include "network.h"
#include "script.h"
#include "main.h"

int keeprun;

int main(int argc, char *argv[])
{
	printf("\n%s %s\n", PROJECT_NAME, PROJECT_VERSION);
	printf("Copyright (C) 2004 %s\n\n", PROJECT_DEVELOPER);

	keeprun = 1;
	
	network_init();
	script_init();
	//todo: ClearBuffers() SockClose();

	printf("This program is free software; you can redistribute it and/or modify\n");
	printf("it under the terms of the GNU General Public License as published by\n");
	printf("the Free Software Foundation; either version 2 of the License, or\n");
	printf("(at your option) any later version.\n\n");
    
	while (keeprun)
	{
		check_key();
		Sleep(10);
		checkconn();
		checkmsg();
	}
    
	network_clean();
	script_clean();
    
	return 0;
}

void check_key()
{
	char c = 0;

	if (kbhit())
		c = getch();

	if (c != 0)
	{
		c = toupper(c);

		switch (c)
		{
		case '?':
			printf("help blah blah...\n");
			break;
		case 'Q':
			keeprun = 0;
			break;
		default:
			printf("Key %c [%x] does not preform a fucntion.\n", c, c);
			break;
		}
	}
}
