#ifndef _H__NETWORK
#define _H__NETWORK

#include <winsock2.h>
#include "account.h"

#define PACKET_LEN_DYNAMIC 0x0000
#define PACKET_LEN_NONE 0xffff

#define LOGIN_NOT_FOUND -3
#define BAD_PASSWORD -4
#define ACCOUNT_BANNED -5
#define ACCOUNT_WIPE -6

#define SERVER_NAME testserver

#define PORT 2593 //Ŀ ũƮ  
#define MAXCLIENT 200
#define MAXBUFFER_REAL 17000 // that's the real buffersize correlating to the client packet buffer
                             // it's 64kb, but you have to consider compression !!! >32 isn't safe.
                             // didn't use 32kb because too much memory (4MB versus 2MB of 17kb)
                             // and I've never seen any packet >10kb on OSI servers.
#define MAXBUFFER_ASYNCH 2560 // Maximum# of bytes for old asynchronous UOX3 packetsend buffer
                              // If buffer exceeded this max they are send in bursts of this sizes.
                              // *NO* correlation to packets.
                              // has to be < MAXBUFFER_REAL
                              // only used for PacketSendStyle UOX3 in server.scp
                              // 2560 is traditional UOX value, unchanged for years ...

static unsigned short  m_packetLen[256]={ 0X68
,  0X5
,  0X7
,  0X0
,  0X2
,  0X5
,  0X5
,  0X7
,  0XE
,  0X5
,  0XB
,  0X10A
,  0X0
,  0X3
,  0X0
,  0X3D
,  0XD7
,  0X0
,  0X0
,  0XA
,  0X6
,  0X9
,  0X1
,  0X0
,  0X0
,  0X0
,  0X0
,  0X25
,  0X0
,  0X5
,  0X4
,  0X8
,  0X13
,  0X8
,  0X3
,  0X1A
,  0X7
,  0X14
,  0X5
,  0X2
,  0X5
,  0X1
,  0X5
,  0X2
,  0X2
,  0X11
,  0XF
,  0XA
,  0X5
,  0X1
,  0X2
,  0X2
,  0XA
,  0X28D
,  0X0
,  0X8
,  0X7
,  0X9
,  0X0
,  0X0
,  0X0
,  0X2
,  0X25
,  0X0
,  0XC9
,  0X0
,  0X0
,  0X229
,  0X2C9
,  0X5
,  0X0
,  0XB
,  0X49
,  0X5D
,  0X5
,  0X9
,  0X0
,  0X0
,  0X6
,  0X2
,  0X0
,  0X0
,  0X0
,  0X2
,  0XC
,  0X1
,  0XB
,  0X6E
,  0X6A
,  0X0
,  0X0
,  0X4
,  0X2
,  0X49
,  0X0
,  0X31
,  0X5
,  0X9
,  0XF
,  0XD
,  0X1
,  0X4
,  0X0
,  0X15
,  0X0
,  0X0
,  0X3
,  0X9
,  0X13
,  0X3
,  0XE
,  0X0
,  0X1C
,  0X0
,  0X5
,  0X2
,  0X0
,  0X23
,  0X10
,  0X11
,  0X0
,  0X9
,  0X0
,  0X2
,  0X0
,  0XD
,  0X2
,  0X0
,  0X3E
,  0X0
,  0X2
,  0X27
,  0X45
,  0X2
,  0X0
,  0X0
,  0X42
,  0X0
,  0X0
,  0X0
,  0XB
,  0X0
,  0X0
,  0X0
,  0X13
,  0X41
,  0X0
,  0X63
,  0X0
,  0X9
,  0X0
,  0X2
,  0X0
,  0X1A
,  0X0
,  0X102
,  0X135
,  0X33
,  0X0
,  0X0
,  0X3
,  0X9
,  0X9
,  0X9
,  0X95
,  0X0
,  0X0
,  0X4
,  0X0
,  0X0
,  0X5
,  0X0
,  0X0
,  0X0
,  0X0
,  0XD
,  0X0
,  0X0
,  0X0
,  0X0
,  0X0
,  0X40
,  0X9
,  0X0
,  0X0
,  0X3
,  0X6
,  0X9
,  0X3
,  0X0
,  0X0
,  0X0
,  0X24
,  0X0
,  0X0
,  0X0
,  0X6
,  0XCB
,  0X1
,  0X31
,  0X2
,  0X6
,  0X6
,  0X7
,  0X0
,  0X1
,  0X0
,  0X4E
,  0X0
,  0X2
,  0X19
,  0X0
,  0X0
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
,  0XFFFF
}; //Ⱑ  ;;

WSADATA wsaData;
int a_socket; //accept 
fd_set conn;
fd_set all;
fd_set errsock;
struct timeval timeout;
struct sockaddr_in connection;
struct sockaddr_in client_addr;
/*unsigned */char buffer[MAXCLIENT][MAXBUFFER_REAL];
char outbuffer[MAXCLIENT][MAXBUFFER_REAL];
int boutlength[MAXCLIENT];

struct client
{
	int socket; //identification...
	unsigned int serial;
	struct account accountinfo;
	int is_new;
	int firstpacket;
} client[MAXCLIENT];

void network_init();
void network_clean();
void checkconn();
void checkmsg();
void disconnect(int s);
void get_msg(int s);
void login_main(int s);
void xsend(int s, char str[], int length);
int xrecv(int s, char str[], int x, int a);
void flush_buffer(int s); // Sends buffered data at once
void relay(int s);
void char_list(int s);

#endif
