#include <stdio.h>
#include "network.h"
#include "account.h"

void account_load()
{
	FILE* file;
	char acctname[ACCOUNT_LENGTH];
	char section[20];
	struct account* acct;

	file = fopen("account.scp", "rt");

	head = NULL;

	while (1)
	{
		if (fgets(temp, READ_LINE_BUFFER_SIZE, file) == NULL)
			break;
imsi:
		if ((temp[0] == '/') && (temp[1] == '/')) // //̰ ּ
		{
			temp[0] = NULL;
			continue;
		}

		if (temp[0] == '[')
		{
			sscanf(temp, "[ %s ]", acctname);
			acct = account_add_to_list(acctname);

			while (1)
			{
				if (fgets(temp, READ_LINE_BUFFER_SIZE, file) == NULL)
					break;
				if (temp[0] == '[')
					goto imsi;

				sscanf(temp, "%s = %s", section, temp);

				if (strcmp(section, "PASSWORD") == 0)
				{
					strncpy(acct->password, temp, PASSWORD_LENGTH);
				}
				else if (strcmp(section, "PLEVEL") == 0)
				{
					;
				}
				section[0] = temp[0] = '\0';
				//blah blah...
			}
			acctname[0] = '\0';
		}
	}
	fclose(file);
}

void account_clean()
{
	struct account* acct;
	struct account* next;

	acct = head;

	while(1)
	{
		next = acct->next;
		if (acct != NULL)
		{
			free(acct);
			acct = NULL;
		}
		acct = next;
		if (acct == NULL)
			return;
	}
}

struct account* account_add_to_list(char acctname[ACCOUNT_LENGTH]) //տ ڷ 
{
	struct account* acct;

	acct = (struct account*)malloc(sizeof(struct account));
	strncpy(acct->account_name, acctname, ACCOUNT_LENGTH);

	if (acct == NULL)
		printf("ERROR: account_add_to_list() NULL!!\n");

	if (head == NULL)
	{
		head = tail = acct;
	}
	else
	{
		tail->next = acct;
		tail = acct;
	}
	tail->next = NULL;

	return acct;
}

void account_remove_from_list(struct account* acct) //Ȥ account_name ޴..
{
	;
}

int authenticate(char* acct, char* pass, int s)
{
	int found = 0;
	char temp[ACCOUNT_LENGTH];
	struct account* ac;

	ac = head;
	strncpy(temp, ac->account_name, ACCOUNT_LENGTH);

	while (!found)
	{
		if (strcmp(temp, acct) == 0)
		{
			found = 1;
		}
		else
		{
			ac = ac->next;
			if ((ac == tail) || (ac == NULL))
				return LOGIN_NOT_FOUND;
			strncpy(temp, ac->account_name, ACCOUNT_LENGTH);
		}
	}

	if (found)
	{
		printf("real pw: %s input: %s\n", ac->password, pass);
		if (strcmp(pass, ac->password) == 0)
		{
			if (ac->is_blocked)
			{
				return ACCOUNT_BANNED;
			}
			else
			{
				client[s].accountinfo = *ac;
				return 1;
			}
		}
		else
			return BAD_PASSWORD;
	}
	return LOGIN_NOT_FOUND; //never reach here
}
