#include <stdio.h>
#include <errno.h>
#include "network.h"
#include "main.h"

int now = 0;

void network_init()
{
	if (WSAStartup((WORD)0x202, &wsaData) == SOCKET_ERROR)
	{
		printf("Error: WSAStartup()\n");
	}
	
	int i;
	for (i = 0; i < 256; i++)
		m_packetLen[i] = 0xffff;
	
	for (i = 0; i < MAXCLIENT; i++)
	{
		client[i].socket = 0;
		client[i].is_new = 1;
		client[i].firstpacket = 1;
		client[i].accountinfo.is_online = 0;
	}
	
	//ߺ ۾ ȴ.   κ ã   ʱȭ ѹ ̴..
	m_packetLen[0x00] = 0x68;	m_packetLen[0x01] = 0x05;	m_packetLen[0x02] = 0x07;	m_packetLen[0x03] = 0x00;	m_packetLen[0x04] = 0x02;	m_packetLen[0x05] = 0x05;	m_packetLen[0x06] = 0x05;	m_packetLen[0x07] = 0x07;
	m_packetLen[0x08] = 0x0E;	m_packetLen[0x09] = 0x05;	m_packetLen[0x0A] = 0x0B;	m_packetLen[0x0B] = 0x10A;	m_packetLen[0x0C] = 0x00;	m_packetLen[0x0D] = 0x03;	m_packetLen[0x0E] = 0x00;	m_packetLen[0x0F] = 0x3D;
	m_packetLen[0x10] = 0xD7;	m_packetLen[0x11] = 0x00;	m_packetLen[0x12] = 0x00;	m_packetLen[0x13] = 0x0A;	m_packetLen[0x14] = 0x06;	m_packetLen[0x15] = 0x09;	m_packetLen[0x16] = 0x01;	m_packetLen[0x17] = 0x00;
	m_packetLen[0x18] = 0x00;	m_packetLen[0x19] = 0x00;	m_packetLen[0x1A] = 0x00;	m_packetLen[0x1B] = 0x25;	m_packetLen[0x1C] = 0x00;	m_packetLen[0x1D] = 0x05;	m_packetLen[0x1E] = 0x04;	m_packetLen[0x1F] = 0x08;
	m_packetLen[0x20] = 0x13;	m_packetLen[0x21] = 0x08;	m_packetLen[0x22] = 0x03;	m_packetLen[0x23] = 0x1A;	m_packetLen[0x24] = 0x07;	m_packetLen[0x25] = 0x14;	m_packetLen[0x26] = 0x05;	m_packetLen[0x27] = 0x02;
	m_packetLen[0x28] = 0x05;	m_packetLen[0x29] = 0x01;	m_packetLen[0x2A] = 0x05;	m_packetLen[0x2B] = 0x02;	m_packetLen[0x2C] = 0x02;	m_packetLen[0x2D] = 0x11;	m_packetLen[0x2E] = 0x0F;	m_packetLen[0x2F] = 0x0A;
	m_packetLen[0x30] = 0x05;	m_packetLen[0x31] = 0x01;	m_packetLen[0x32] = 0x02;	m_packetLen[0x33] = 0x02;	m_packetLen[0x34] = 0x0A;	m_packetLen[0x35] = 0x28D;	m_packetLen[0x36] = 0x00;	m_packetLen[0x37] = 0x08;
	m_packetLen[0x38] = 0x07;	m_packetLen[0x39] = 0x09;	m_packetLen[0x3A] = 0x00;	m_packetLen[0x3B] = 0x00;	m_packetLen[0x3C] = 0x00;	m_packetLen[0x3D] = 0x02;	m_packetLen[0x3E] = 0x25;	m_packetLen[0x3F] = 0x00;
	m_packetLen[0x40] = 0xC9;	m_packetLen[0x41] = 0x00;	m_packetLen[0x42] = 0x00;	m_packetLen[0x43] = 0x229;	m_packetLen[0x44] = 0x2C9;	m_packetLen[0x45] = 0x05;	m_packetLen[0x46] = 0x00;	m_packetLen[0x47] = 0x0B;
	m_packetLen[0x48] = 0x49;	m_packetLen[0x49] = 0x5D;	m_packetLen[0x4A] = 0x05;	m_packetLen[0x4B] = 0x09;	m_packetLen[0x4C] = 0x00;	m_packetLen[0x4D] = 0x00;	m_packetLen[0x4E] = 0x06;	m_packetLen[0x4F] = 0x02;
	m_packetLen[0x50] = 0x00;	m_packetLen[0x51] = 0x00;	m_packetLen[0x52] = 0x00;	m_packetLen[0x53] = 0x02;	m_packetLen[0x54] = 0x0C;	m_packetLen[0x55] = 0x01;	m_packetLen[0x56] = 0x0B;	m_packetLen[0x57] = 0x6E;
	m_packetLen[0x58] = 0x6A;	m_packetLen[0x59] = 0x00;	m_packetLen[0x5A] = 0x00;	m_packetLen[0x5B] = 0x04;	m_packetLen[0x5C] = 0x02;	m_packetLen[0x5D] = 0x49;	m_packetLen[0x5E] = 0x00;	m_packetLen[0x5F] = 0x31;
	m_packetLen[0x60] = 0x05;	m_packetLen[0x61] = 0x09;	m_packetLen[0x62] = 0x0F;	m_packetLen[0x63] = 0x0D;	m_packetLen[0x64] = 0x01;	m_packetLen[0x65] = 0x04;	m_packetLen[0x66] = 0x00;	m_packetLen[0x67] = 0x15;
	m_packetLen[0x68] = 0x00;	m_packetLen[0x69] = 0x00;	m_packetLen[0x6A] = 0x03;	m_packetLen[0x6B] = 0x09;	m_packetLen[0x6C] = 0x13;	m_packetLen[0x6D] = 0x03;	m_packetLen[0x6E] = 0x0E;	m_packetLen[0x6F] = 0x00;
	m_packetLen[0x70] = 0x1C;	m_packetLen[0x71] = 0x00;	m_packetLen[0x72] = 0x05;	m_packetLen[0x73] = 0x02;	m_packetLen[0x74] = 0x00;	m_packetLen[0x75] = 0x23;	m_packetLen[0x76] = 0x10;	m_packetLen[0x77] = 0x11;
	m_packetLen[0x78] = 0x00;	m_packetLen[0x79] = 0x09;	m_packetLen[0x7A] = 0x00;	m_packetLen[0x7B] = 0x02;	m_packetLen[0x7C] = 0x00;	m_packetLen[0x7D] = 0x0D;	m_packetLen[0x7E] = 0x02;	m_packetLen[0x7F] = 0x00;
	m_packetLen[0x80] = 0x3E;	m_packetLen[0x81] = 0x00;	m_packetLen[0x82] = 0x02;	m_packetLen[0x83] = 0x27;	m_packetLen[0x84] = 0x45;	m_packetLen[0x85] = 0x02;	m_packetLen[0x86] = 0x00;	m_packetLen[0x87] = 0x00;
	m_packetLen[0x88] = 0x42;	m_packetLen[0x89] = 0x00;	m_packetLen[0x8A] = 0x00;	m_packetLen[0x8B] = 0x00;	m_packetLen[0x8C] = 0x0B;	m_packetLen[0x8D] = 0x00;	m_packetLen[0x8E] = 0x00;	m_packetLen[0x8F] = 0x00;
	m_packetLen[0x90] = 0x13;	m_packetLen[0x91] = 0x41;	m_packetLen[0x92] = 0x00;	m_packetLen[0x93] = 0x63;	m_packetLen[0x94] = 0x00;	m_packetLen[0x95] = 0x09;	m_packetLen[0x96] = 0x00;	m_packetLen[0x97] = 0x02;
	m_packetLen[0x98] = 0x00;	m_packetLen[0x99] = 0x1A;	m_packetLen[0x9A] = 0x00;	m_packetLen[0x9B] = 0x102;	m_packetLen[0x9C] = 0x135;	m_packetLen[0x9D] = 0x33;	m_packetLen[0x9E] = 0x00;	m_packetLen[0x9F] = 0x00;
	m_packetLen[0xA0] = 0x03;	m_packetLen[0xA1] = 0x09;	m_packetLen[0xA2] = 0x09;	m_packetLen[0xA3] = 0x09;	m_packetLen[0xA4] = 0x95;	m_packetLen[0xA5] = 0x00;	m_packetLen[0xA6] = 0x00;	m_packetLen[0xA7] = 0x04;
	m_packetLen[0xA8] = 0x00;	m_packetLen[0xA9] = 0x00;	m_packetLen[0xAA] = 0x05;	m_packetLen[0xAB] = 0x00;	m_packetLen[0xAC] = 0x00;	m_packetLen[0xAD] = 0x00;	m_packetLen[0xAE] = 0x00;	m_packetLen[0xAF] = 0x0D;
	m_packetLen[0xB0] = 0x00;	m_packetLen[0xB1] = 0x00;	m_packetLen[0xB2] = 0x00;	m_packetLen[0xB3] = 0x00;	m_packetLen[0xB4] = 0x00;	m_packetLen[0xB5] = 0x40;	m_packetLen[0xB6] = 0x09;	m_packetLen[0xB7] = 0x00;
	m_packetLen[0xB8] = 0x00;	m_packetLen[0xB9] = 0x03;	m_packetLen[0xBA] = 0x06;	m_packetLen[0xBB] = 0x09;	m_packetLen[0xBC] = 0x03;	m_packetLen[0xBD] = 0x00;	m_packetLen[0xBE] = 0x00;	m_packetLen[0xBF] = 0x00;
	m_packetLen[0xC0] = 0x24;	m_packetLen[0xC1] = 0x00;   m_packetLen[0xC2] = 0x00;   m_packetLen[0xC3] = 0x00;   m_packetLen[0xC4] = 0x06;   m_packetLen[0xC5] = 0xCB;   m_packetLen[0xC6] = 0x01;   m_packetLen[0xC7] = 0x31;
	m_packetLen[0xC8] = 0x02;   m_packetLen[0xC9] = 0x06;   m_packetLen[0xCA] = 0x06;   m_packetLen[0xCB] = 0x07;   m_packetLen[0xCC] = 0x00;   m_packetLen[0xCD] = 0x01;   m_packetLen[0xCE] = 0x00;   m_packetLen[0xCF] = 0x00;
	m_packetLen[0xD0] = 0x00;   m_packetLen[0xD1] = 0x00;   m_packetLen[0xD2] = 0x19;   m_packetLen[0xD3] = 0x00;   m_packetLen[0xD4] = 0x00;
	
	a_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (a_socket < 0)
	{
		printf("Error: socket()\n");
	}
	
	connection.sin_family = AF_INET;
	connection.sin_addr.s_addr = INADDR_ANY;
	connection.sin_port = htons(PORT);
	
	if (bind(a_socket, (struct sockaddr*)&connection, sizeof(struct sockaddr_in)) != 0)
	{
		printf("Error: bind()\n");
	}
	
	if (listen(a_socket, MAXCLIENT) != 0)
	{
		printf("Error: listen()\n");
	}
	
	ioctlsocket(a_socket,FIONBIO,0);
}

void network_clean()
{
	WSACleanup();
}

void checkconn()
{
	int s;
	int FAR len;
	
	if (now > MAXCLIENT)
		return;
	
	FD_ZERO(&conn);
	FD_SET(a_socket, &conn);
	int nfds = a_socket + 1;
	
	s = select(nfds, &conn, NULL, NULL, &timeout);// Ư  ׻ ó  ֱ    select() ص ɻ   ٰ Ѵ
	
	if (s > 0)
	{
		len = sizeof (struct sockaddr_in);
		client[now].socket = accept(a_socket, (struct sockaddr*)&client_addr, &len);
		if (client[now].socket < 0)
		{
			printf("Error: accept()\n");
			return;
		}
		
		printf("%d connected. [%i.%i.%i.%i] Total %d\n", client[now].socket, client_addr.sin_addr.s_addr&0xFF, (client_addr.sin_addr.s_addr&0xFF00)>>8, (client_addr.sin_addr.s_addr&0xFF0000)>>16, (client_addr.sin_addr.s_addr&0xFF000000)>>24, now + 1);
		now++;
	}
}

void checkmsg()
{
	int nfds, i, s, oldnow = 0;
	
	FD_ZERO(&all);
	FD_ZERO(&errsock);
	
	for (i = 0; i < now; i++)
	{
		FD_SET(client[i].socket, &all);
		FD_SET(client[i].socket, &errsock);
		if (client[i].socket + 1 > nfds)
			nfds = client[i].socket + 1;
	}
	
	s = select(nfds, &all, NULL, &errsock, &timeout);
	
	if (s > 0)
	{
		oldnow = now; //now ٲ  ־...  ĵ ϴ -_-;
		for (i = 0; i < oldnow; i++)
		{
			if (FD_ISSET(client[i].socket, &errsock))
			{
				disconnect(i);
			}
			
			if (FD_ISSET(client[i].socket, &all) && (oldnow==now))
			{
				get_msg(i);
			}
		}
	}
}

void disconnect(int s)
{
	int i;
	printf("Client %d is disconnected.\n", s);
	closesocket(client[s].socket);
	client[s].socket = client[now - 1].socket; //  𸥴
	client[now - 1].socket = 0;
	//client[s].socket = 0;
	now--;
}

void get_msg(int s)
{
	int count, length, dyn_length = 0;
	unsigned char packet;
	
	memset(buffer[s], 0, sizeof(buffer[s]));
	
	if (client[s].is_new)
	{
		if (xrecv(client[s].socket, (char*)buffer[s], 4 , 0) != 4)
			return;
		client[s].is_new = 0;
		client[s].firstpacket = 1;
		return;
	}
	
	if (xrecv(client[s].socket, (char*)buffer[s], 1, 0) < 0)
		return;
	
	packet = buffer[s][0];
	length = m_packetLen[packet];
	
	if (client[s].firstpacket && packet != 0x80 && packet !=0x91 )
	{
		disconnect(s);
		printf("received garbage from a client, disconnected it to prevent bad things.\n User probably didnt use ignition\n");
		return;
	}
	
	if (length == PACKET_LEN_NONE)
	{
		printf("received unknown packet from user.\n");
		disconnect(s);
		return;
	}
	
	if (length == PACKET_LEN_DYNAMIC)
	{
		if (xrecv(client[s].socket, (char*)buffer[s], 2, 1) > 0)
		{
			dyn_length = (int)(((int)buffer[s][1] << 8) + (int)buffer[s][2]);
			count = xrecv(client[s].socket, (char*)buffer[s], dyn_length - 3, 3);
		}
	}
	else
	{
		count = xrecv(client[s].socket, (char*)buffer[s], length - 1, 1);
	}
	
	if (count == SOCKET_ERROR)
		disconnect(s);
	
	printf("packet: %x\n", packet);
	
	switch (packet) //http://www.kairtech.com/uo/info 
	{
	case 0x80: // First Login
		client[s].firstpacket = 0;
		login_main(s);
		break;
	case 0x91:// Second Login
		client[s].firstpacket = 0;
		char_list(s);
		//CharList(s);
		break;
	case 0xA0:// Server Select
		relay(s);
		break;
	case 0x00:// Character Create,  ?
		break;
	case 0x06:// Double click
		break;
	case 0x09:// Single click
		break;
	case 0x02:// Walk
		break;
	case 0x73:// Keep alive
		xsend(s, buffer[s], 2);
		break;
	case 0x83:// Character Delete
		break;
	case 0x5D:// Character Select
		break;
	case 0xA4:// Spy
		break;
	default:
		printf("i don't know %x\n", packet);
		break;
	}
}

void login_main(int s)
{
	signed long int i = 0;
	int loopexit = 0;
	unsigned char noaccount[3]="\x82\x00";
	unsigned char acctused[3]="\x82\x01";
	unsigned char nopass[3]="\x82\x03";
	unsigned char acctblock[3]="\x82\x02";

	char pass0[256];
	char pass1[PASSWORD_LENGTH];
	char pass2[PASSWORD_LENGTH];
	
	printf("great!\nid:%s\n", (char*)&buffer[s]);
	
	strcpy(pass0, (char*)&buffer[s][30]);
	pass1[0] = 0;
	while ((pass0[i] != '/') && (pass0[i] != 0) && (++loopexit < 250000)) //  -_-;
		i++;
	strncpy(pass1, pass0, i);
	pass1[i] = 0;
	if (pass0[i] != 0)
		strcpy(pass2, pass0 + i + 1);
	
	i = authenticate((char*)&buffer[s], (char*)pass1, s);
	if (i < 0)
	{
		switch(i)  //Let's check for the error message
		{
		case BAD_PASSWORD:
			xsend(s, nopass, 2);
			return;
		case ACCOUNT_BANNED:
			xsend(s, acctblock, 2);	
			return;
		case LOGIN_NOT_FOUND:
			xsend(s, noaccount, 2);
			return;
		}
	}

	if (client[s].accountinfo.is_online)
	{
		xsend(s, acctused, 2);
		return;
	}

	if (client[s].accountinfo.account_name[0] != 0)
	{
		//  Ʈ ϰ   ڵ ߰ ʿ
		unsigned long int ip;
		unsigned char newlist1[7] = "\xA8\x01\x23\xFF\x00\x01";
		unsigned char newlist2[41] = "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x12\x01\x7F\x00\x00\x01";
		
		newlist1[1] = 0;
		newlist1[2] = 46;
		newlist1[4] = 0;
		newlist1[5] = 1;
		xsend(s, newlist1, 6);

		newlist2[0] = (unsigned char)0;
		newlist2[1] = (unsigned char)1;
		
		strncpy((char*)&newlist2[2], "servername", 32);
		ip = inet_addr("127.0.0.1");
		newlist2[39] = (unsigned char)(ip >> 24);
		newlist2[38] = (unsigned char)(ip >> 16);
		newlist2[37] = (unsigned char)(ip >> 8);
		newlist2[36] = (unsigned char)(ip % 256);
		xsend(s, newlist2, 40);
	}
}

void xsend(int s, char str[], int length) //۸ ʿ
{
	if (send(client[s].socket, str, length, 0) == SOCKET_ERROR)
	{
		errno = WSAGetLastError();
		if (errno != WSAECONNRESET)
			printf("ERROR: flush_buffer()\n");
	}
	printf("send: %s length: %d\n", str, length);
}

int xrecv(int s, char str[], int x, int a)
{
	int count = 0;
	
	if ((x + a) >= MAXBUFFER_ASYNCH)
		return 0;
	
	unsigned int timeHere = timeGetTime();
	
	do {
		int temp = recv(s, str, x, 0);
		if (temp)
			printf("recv: %s\n", str);
		fflush(stdout);
		
		if (temp > 0)
		{
			count += temp;
			x -= temp;
		}
		else if (temp == 0)
		{
			return count == 0 ? -1 : count;
		}
		else if (temp < 0)
		{
			return -1;
		}
	} while (x > 0 && ( timeHere + 5 * 1000 ) > timeGetTime()); //can be adjusted
	
	return count;
}

void relay(int s)
{
	unsigned long int ip;
	unsigned char login03[12];

	ip = inet_addr("127.0.0.1");
	login03[0] = 0x8C; //right?
	login03[4] = (unsigned char) (ip >> 24);
	login03[3] = (unsigned char) (ip >> 16);
	login03[2] = (unsigned char) (ip >> 8);
	login03[1] = (unsigned char) (ip % 256);
	login03[5] = PORT >> 8;
	login03[6] = PORT % 256;
	//srand(ip + acctno[s] + now + uiCurrentTime); // Perform randomize
	login03[7] = 127;
	login03[8] = 0;
	login03[9] = 0;
	login03[10] = 1;
	xsend(s, login03, 11);
}

void char_list(int s) //Ӽ ٽ ó.  ü ̹Ƿ  ..   :)
{
	unsigned char login04b[61] = {0,};
	int tlen;

	tlen = 4 + (5 * 60) + 1 + (/*startLocation() start.size()*/1 * 63);
	login04a[1]=tlen>>8;
	login04a[2]=tlen%256;
	//GoodAuth(s);
}