//==================================================================================
//
//      UOFree emu
//	UO Server Emulation Program
//
//	Copyright 2004 by pyj200
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	* In addition to that license, if you are running this program or modified
//	* versions of it on a public system you HAVE TO make the complete source of
//	* the version used by you available or provide people with a location to
//	* download it.
//
//========================================================================================

#if !defined(__EXCEPTIONS_H__)
#define __EXCEPTIONS_H__
// Platform specifics
#include "platform.h"

// System Includes
#include <exception>
#include <string>

namespace wp_exceptions
{
	// Exceptions trown by ItemManager:
//##ModelId=3C5D92F5009E
	class wpbad_ptr : public std::exception
	{
	private:
		std::string m_Error;
	public:
	//##ModelId=3C5D92F500E4
		wpbad_ptr(std::string sError) throw() : m_Error(sError) {};
	//##ModelId=3C5D92F500F8
		virtual const char *what() const throw()
		{
			return m_Error.c_str();
		}
		~wpbad_ptr() throw(){} ;
	};
	
};

#endif // __EXCEPTIONS_H__
